GDAL

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Friends | List of all members
OGRCurve Class Referenceabstract

Abstract curve base class for OGRLineString, OGRCircularString and OGRCompoundCurve. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRCurve:

## Public Types
typedef OGRPoint | ChildType
| Type of child elements.

## Public Member Functions
ConstIterator | begin () const
| Return begin of a point iterator. More...
ConstIterator | end () const
| Return end of a point iterator.
virtual OGRCurve * | clone () const override=0
| Make a copy of this object. More...
virtual double | get_Length () const =0
| Returns the length of the curve. More...
virtual void | StartPoint (OGRPoint *) const =0
| Return the curve start point. More...
virtual void | EndPoint (OGRPoint *) const =0
| Return the curve end point. More...
virtual int | get_IsClosed () const
| Return TRUE if curve is closed. More...
virtual void | Value (double, OGRPoint *) const =0
| Fetch point at given distance along curve. More...
virtual OGRLineString * | CurveToLine (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=nullptr) const =0
| Return a linestring from a curve geometry. More...
virtual int | getDimension () const override
| Get the dimension of this object. More...
virtual int | getNumPoints () const =0
| Return the number of points of a curve geometry. More...
virtual OGRPointIterator * | getPointIterator () const =0
| Returns a point iterator over the curve. More...
virtual OGRBoolean | IsConvex () const
| Returns if a (closed) curve forms a convex shape. More...
virtual double | get_Area () const =0
| Get the area of the (closed) curve. More...
OGRSimpleCurve * | toSimpleCurve ()
| Down-cast to OGRSimpleCurve*. More...
const OGRSimpleCurve * | toSimpleCurve () const
| Down-cast to OGRSimpleCurve*. More...
bool | operator== (const OGRGeometry &other) const
| Returns if two geometries are equal.
bool | operator!= (const OGRGeometry &other) const
| Returns if two geometries are different.
virtual int | getCoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
int | CoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
virtual OGRBoolean | IsEmpty () const =0
| Returns TRUE (non-zero) if the object has no points. More...
virtual OGRBoolean | IsValid () const
| Test if the geometry is valid. More...
virtual OGRGeometry * | MakeValid (CSLConstList papszOptions=nullptr) const
| Attempts to make an invalid geometry valid without losing vertices. More...
virtual OGRGeometry * | Normalize () const
| Attempts to bring geometry into normalized/canonical form. More...
virtual OGRBoolean | IsSimple () const
| Test if the geometry is simple. More...
OGRBoolean | Is3D () const
OGRBoolean | IsMeasured () const
virtual OGRBoolean | IsRing () const
| Test if the geometry is a ring. More...
virtual void | empty ()=0
| Clear geometry information. This restores the geometry to its initial state after construction, and before assignment of actual geometry. More...
virtual void | getEnvelope (OGREnvelope *psEnvelope) const =0
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure. More...
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const =0
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure. More...
virtual size_t | WkbSize () const =0
| Returns size of related binary representation. More...
OGRErr | importFromWkb (const GByte *, size_t=static_cast< size_t >(-1), OGRwkbVariant=wkbVariantOldOgc)
| Assign geometry from well known binary data. More...
virtual OGRErr | importFromWkb (const unsigned char *, size_t, OGRwkbVariant, size_t &nBytesConsumedOut)=0
| Assign geometry from well known binary data. More...
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const =0
| Convert a geometry into well known binary format. More...
virtual OGRErr | importFromWkt (const char **ppszInput)=0
| Assign geometry from well known text data. More...
OGRErr | importFromWkt (char **ppszInput)
| Deprecated. More...
OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known text format. More...
virtual std::string | exportToWkt (const OGRWktOptions &opts=OGRWktOptions(), OGRErr *err=nullptr) const =0
| Export a WKT geometry. More...
virtual OGRwkbGeometryType | getGeometryType () const =0
| Fetch geometry type. More...
OGRwkbGeometryType | getIsoGeometryType () const
| Get the geometry type that conforms with ISO SQL/MM Part3. More...
virtual const char * | getGeometryName () const =0
| Fetch WKT name for geometry type. More...
virtual void | dumpReadable (FILE *, const char *=nullptr, char **papszOptions=nullptr) const
| Dump geometry in well known text format to indicated output file. More...
virtual void | flattenTo2D ()=0
| Convert geometry to strictly 2D. In a sense this converts all Z coordinates to 0.0. More...
virtual char * | exportToGML (const char *const *papszOptions=nullptr) const
| Convert a geometry into GML format. More...
virtual char * | exportToKML () const
| Convert a geometry into KML format. More...
virtual char * | exportToJson () const
| Convert a geometry into GeoJSON format. More...
virtual void | accept (IOGRGeometryVisitor *visitor)=0
| Accept a visitor.
virtual void | accept (IOGRConstGeometryVisitor *visitor) const =0
| Accept a visitor.
virtual GEOSGeom | exportToGEOS (GEOSContextHandle_t hGEOSCtxt) const
| Returns a GEOSGeom object corresponding to the geometry. More...
virtual OGRBoolean | hasCurveGeometry (int bLookForNonLinear=FALSE) const
| Returns if this geometry is or has curve geometry. More...
virtual OGRGeometry * | getCurveGeometry (const char *const *papszOptions=nullptr) const
| Return curve version of this geometry. More...
virtual OGRGeometry * | getLinearGeometry (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=nullptr) const
| Return, possibly approximate, non-curve version of this geometry. More...
virtual void | closeRings ()
| Force rings to be closed. More...
virtual void | setCoordinateDimension (int nDimension)
| Set the coordinate dimension. More...
virtual void | set3D (OGRBoolean bIs3D)
| Add or remove the Z coordinate dimension. More...
virtual void | setMeasured (OGRBoolean bIsMeasured)
| Add or remove the M coordinate dimension. More...
virtual void | assignSpatialReference (OGRSpatialReference *poSR)
| Assign spatial reference to this object. More...
OGRSpatialReference * | getSpatialReference (void) const
| Returns spatial reference system for object. More...
virtual OGRErr | transform (OGRCoordinateTransformation *poCT)=0
| Apply arbitrary coordinate transformation to geometry. More...
OGRErr | transformTo (OGRSpatialReference *poSR)
| Transform geometry to new spatial reference system. More...
virtual void | segmentize (double dfMaxLength)
| Modify the geometry such it has no segment longer then the given distance. More...
virtual OGRBoolean | Intersects (const OGRGeometry *) const
| Do these features intersect? More...
virtual OGRBoolean | Equals (const OGRGeometry *) const =0
| Returns TRUE if two geometries are equivalent. More...
virtual OGRBoolean | Disjoint (const OGRGeometry *) const
| Test for disjointness. More...
virtual OGRBoolean | Touches (const OGRGeometry *) const
| Test for touching. More...
virtual OGRBoolean | Crosses (const OGRGeometry *) const
| Test for crossing. More...
virtual OGRBoolean | Within (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Contains (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Overlaps (const OGRGeometry *) const
| Test for overlap. More...
virtual OGRGeometry * | Boundary () const
| Compute boundary. More...
virtual double | Distance (const OGRGeometry *) const
| Compute distance between two geometries. More...
virtual OGRGeometry * | ConvexHull () const
| Compute convex hull. More...
virtual OGRGeometry * | Buffer (double dfDist, int nQuadSegs=30) const
| Compute buffer of geometry. More...
virtual OGRGeometry * | Intersection (const OGRGeometry *) const
| Compute intersection. More...
virtual OGRGeometry * | Union (const OGRGeometry *) const
| Compute union. More...
virtual OGRGeometry * | UnionCascaded () const
| Compute union using cascading. More...
virtual OGRGeometry * | Difference (const OGRGeometry *) const
| Compute difference. More...
virtual OGRGeometry * | SymDifference (const OGRGeometry *) const
| Compute symmetric difference. More...
virtual OGRErr | Centroid (OGRPoint *poPoint) const
| Compute the geometry centroid. More...
virtual OGRGeometry * | Simplify (double dTolerance) const
| Simplify the geometry. More...
OGRGeometry * | SimplifyPreserveTopology (double dTolerance) const
| Simplify the geometry while preserving topology. More...
virtual OGRGeometry * | DelaunayTriangulation (double dfTolerance, int bOnlyEdges) const
| Return a Delaunay triangulation of the vertices of the geometry. More...
virtual OGRGeometry * | Polygonize () const
| Polygonizes a set of sparse edges. More...
virtual double | Distance3D (const OGRGeometry *poOtherGeom) const
| Returns the 3D distance between two geometries. More...
virtual void | swapXY ()
| Swap x and y coordinates. More...
OGRPoint * | toPoint ()
| Down-cast to OGRPoint*. More...
const OGRPoint * | toPoint () const
| Down-cast to OGRPoint*. More...
OGRCurve * | toCurve ()
| Down-cast to OGRCurve*. More...
const OGRCurve * | toCurve () const
| Down-cast to OGRCurve*. More...
OGRLineString * | toLineString ()
| Down-cast to OGRLineString*. More...
const OGRLineString * | toLineString () const
| Down-cast to OGRLineString*. More...
OGRLinearRing * | toLinearRing ()
| Down-cast to OGRLinearRing*. More...
const OGRLinearRing * | toLinearRing () const
| Down-cast to OGRLinearRing*. More...
OGRCircularString * | toCircularString ()
| Down-cast to OGRCircularString*. More...
const OGRCircularString * | toCircularString () const
| Down-cast to OGRCircularString*. More...
OGRCompoundCurve * | toCompoundCurve ()
| Down-cast to OGRCompoundCurve*. More...
const OGRCompoundCurve * | toCompoundCurve () const
| Down-cast to OGRCompoundCurve*. More...
OGRSurface * | toSurface ()
| Down-cast to OGRSurface*. More...
const OGRSurface * | toSurface () const
| Down-cast to OGRSurface*. More...
OGRPolygon * | toPolygon ()
| Down-cast to OGRPolygon*. More...
const OGRPolygon * | toPolygon () const
| Down-cast to OGRPolygon*. More...
OGRTriangle * | toTriangle ()
| Down-cast to OGRTriangle*. More...
const OGRTriangle * | toTriangle () const
| Down-cast to OGRTriangle*. More...
OGRCurvePolygon * | toCurvePolygon ()
| Down-cast to OGRCurvePolygon*. More...
const OGRCurvePolygon * | toCurvePolygon () const
| Down-cast to OGRCurvePolygon*. More...
OGRGeometryCollection * | toGeometryCollection ()
| Down-cast to OGRGeometryCollection*. More...
const OGRGeometryCollection * | toGeometryCollection () const
| Down-cast to OGRGeometryCollection*. More...
OGRMultiPoint * | toMultiPoint ()
| Down-cast to OGRMultiPoint*. More...
const OGRMultiPoint * | toMultiPoint () const
| Down-cast to OGRMultiPoint*. More...
OGRMultiLineString * | toMultiLineString ()
| Down-cast to OGRMultiLineString*. More...
const OGRMultiLineString * | toMultiLineString () const
| Down-cast to OGRMultiLineString*. More...
OGRMultiPolygon * | toMultiPolygon ()
| Down-cast to OGRMultiPolygon*. More...
const OGRMultiPolygon * | toMultiPolygon () const
| Down-cast to OGRMultiPolygon*. More...
OGRMultiCurve * | toMultiCurve ()
| Down-cast to OGRMultiCurve*. More...
const OGRMultiCurve * | toMultiCurve () const
| Down-cast to OGRMultiCurve*. More...
OGRMultiSurface * | toMultiSurface ()
| Down-cast to OGRMultiSurface*. More...
const OGRMultiSurface * | toMultiSurface () const
| Down-cast to OGRMultiSurface*. More...
OGRPolyhedralSurface * | toPolyhedralSurface ()
| Down-cast to OGRPolyhedralSurface*. More...
const OGRPolyhedralSurface * | toPolyhedralSurface () const
| Down-cast to OGRPolyhedralSurface*. More...
OGRTriangulatedSurface * | toTriangulatedSurface ()
| Down-cast to OGRTriangulatedSurface*. More...
const OGRTriangulatedSurface * | toTriangulatedSurface () const
| Down-cast to OGRTriangulatedSurface*. More...

## Static Public Member Functions
static OGRCompoundCurve * | CastToCompoundCurve (OGRCurve *puCurve)
| Cast to compound curve. More...
static OGRLineString * | CastToLineString (OGRCurve *poCurve)
| Cast to linestring. More...
static OGRLinearRing * | CastToLinearRing (OGRCurve *poCurve)
| Cast to linear ring. More...
static GEOSContextHandle_t | createGEOSContext ()
| Create a new GEOS context. More...
static void | freeGEOSContext (GEOSContextHandle_t hGEOSCtxt)
| Destroy a GEOS context. More...
static OGRGeometryH | ToHandle (OGRGeometry *poGeom)
| Convert a OGRGeometry* to a OGRGeometryH. More...
static OGRGeometry * | FromHandle (OGRGeometryH hGeom)
| Convert a OGRGeometryH to a OGRGeometry*. More...

## Protected Member Functions
virtual int | ContainsPoint (const OGRPoint *p) const
| Returns if a point is contained in a (closed) curve. More...
virtual int | IntersectsPoint (const OGRPoint *p) const
| Returns if a point intersects a (closed) curve. More...
virtual double | get_AreaOfCurveSegments () const =0
| Get the area of the purely curve portions of a (closed) curve. More...

## Friends
ConstIterator | begin (const OGRCurve *)
ConstIterator | end (const OGRCurve *)

## Detailed Description

Abstract curve base class for OGRLineString, OGRCircularString and OGRCompoundCurve.

## Member Function Documentation

## ◆ assignSpatialReference()

void OGRGeometry::assignSpatialReference | ( | OGRSpatialReference * | poSR | ) |
| virtual inherited

Assign spatial reference to this object.

Any existing spatial reference is replaced, but under no circumstances does this result in the object being reprojected. It is just changing the interpretation of the existing geometry. Note that assigning a spatial reference increments the reference count on the OGRSpatialReference, but does not copy it.

Starting with GDAL 2.3, this will also assign the spatial reference to potential sub-geometries of the geometry (OGRGeometryCollection, OGRCurvePolygon/OGRPolygon, OGRCompoundCurve, OGRPolyhedralSurface and their derived classes).

This is similar to the SFCOM IGeometry::put_SpatialReference() method.

This method is the same as the C function OGR_G_AssignSpatialReference().

Parameters

  poSR | new spatial reference system to apply.

Reimplemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRCurvePolygon, and OGRCompoundCurve.

## ◆ begin()

OGRCurve::ConstIterator OGRCurve::begin | ( |  | ) | const

Return begin of a point iterator.

Using this iterator for standard range-based loops is safe, but due to implementation limitations, you shouldn't try to access (dereference) more than one iterator step at a time, since you will get a reference to the same OGRPoint& object.

Since
  GDAL 2.3

## ◆ Boundary()

OGRGeometry * OGRGeometry::Boundary | ( |  | ) | const
| virtual inherited

Compute boundary.

A new geometry object is created and returned containing the boundary of the geometry on which the method is invoked.

This method is the same as the C function OGR_G_Boundary().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a newly allocated geometry now owned by the caller, or NULL on failure.

Since
  OGR 1.8.0

## ◆ Buffer()

OGRGeometry * OGRGeometry::Buffer | ( | double | dfDist,
|  | int | nQuadSegs = `30`
| ) |  | const
| virtual inherited

Compute buffer of geometry.

Builds a new geometry containing the buffer region around the geometry on which it is invoked. The buffer is a polygon containing the region within the buffer distance of the original geometry.

Some buffer sections are properly described as curves, but are converted to approximate polygons. The nQuadSegs parameter can be used to control how many segments should be used to define a 90 degree curve - a quadrant of a circle. A value of 30 is a reasonable default. Large values result in large numbers of vertices in the resulting buffer geometry while small numbers reduce the accuracy of the result.

This method is the same as the C function OGR_G_Buffer().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  dfDist | the buffer distance to be applied. Should be expressed into the same unit as the coordinates of the geometry.
  nQuadSegs | the number of segments used to approximate a 90 degree (quadrant) of curvature.

Returns
  the newly created geometry, or NULL if an error occurs.

## ◆ CastToCompoundCurve()

OGRCompoundCurve * OGRCurve::CastToCompoundCurve | ( | OGRCurve * | poCurve | ) |
| static

Cast to compound curve.

The passed in geometry is consumed and a new one returned (or NULL in case of failure)

Parameters

  poCurve | the input geometry - ownership is passed to the method.

Returns
  new geometry

Since
  GDAL 2.0

## ◆ CastToLinearRing()

OGRLinearRing * OGRCurve::CastToLinearRing | ( | OGRCurve * | poCurve | ) |
| static

Cast to linear ring.

The passed in geometry is consumed and a new one returned (or NULL in case of failure)

Parameters

  poCurve | the input geometry - ownership is passed to the method.

Returns
  new geometry.

Since
  GDAL 2.0

## ◆ CastToLineString()

OGRLineString * OGRCurve::CastToLineString | ( | OGRCurve * | poCurve | ) |
| static

Cast to linestring.

The passed in geometry is consumed and a new one returned (or NULL in case of failure)

Parameters

  poCurve | the input geometry - ownership is passed to the method.

Returns
  new geometry.

Since
  GDAL 2.0

## ◆ Centroid()

OGRErr OGRGeometry::Centroid | ( | OGRPoint * | poPoint | ) | const
| virtual inherited

Compute the geometry centroid.

The centroid location is applied to the passed in OGRPoint object. The centroid is not necessarily within the geometry.

This method relates to the SFCOM ISurface::get_Centroid() method however the current implementation based on GEOS can operate on other geometry types such as multipoint, linestring, geometrycollection such as multipolygons. OGC SF SQL 1.1 defines the operation for surfaces (polygons). SQL/MM-Part 3 defines the operation for surfaces and multisurfaces (multipolygons).

This function is the same as the C function OGR_G_Centroid().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Returns
  OGRERR_NONE on success or OGRERR_FAILURE on error.

Since
  OGR 1.8.0 as a OGRGeometry method (previously was restricted to OGRPolygon)

## ◆ clone()

virtual OGRCurve* OGRCurve::clone | ( |  | ) | const
| override pure virtual

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns
  a new object instance with the same geometry, and spatial reference system as the original.

Implements OGRGeometry.

Implemented in OGRSimpleCurve, OGRCompoundCurve, OGRCircularString, OGRLinearRing, and OGRLineString.

## ◆ closeRings()

void OGRGeometry::closeRings | ( |  | ) |
| virtual inherited

Force rings to be closed.

If this geometry, or any contained geometries has polygon rings that are not closed, they will be closed by adding the starting point at the end.

Reimplemented in OGRGeometryCollection, OGRPolygon, and OGRLinearRing.

## ◆ Contains()

OGRBoolean OGRGeometry::Contains | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for containment.

Tests if actual geometry object contains the passed geometry.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Contains().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if poOtherGeom contains this geometry, otherwise FALSE.

Reimplemented in OGRCurvePolygon.

## ◆ ContainsPoint()

int OGRCurve::ContainsPoint | ( | const OGRPoint * | p | ) | const
| protected virtual

Returns if a point is contained in a (closed) curve.

Final users should use OGRGeometry::Contains() instead.

Parameters

  p | the point to test

Returns
  TRUE if it is inside the curve, FALSE otherwise or -1 if unknown.

Since
  GDAL 2.0

## ◆ ConvexHull()

OGRGeometry * OGRGeometry::ConvexHull | ( |  | ) | const
| virtual inherited

Compute convex hull.

A new geometry object is created and returned containing the convex hull of the geometry on which the method is invoked.

This method is the same as the C function OGR_G_ConvexHull().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a newly allocated geometry now owned by the caller, or NULL on failure.

## ◆ CoordinateDimension()

int OGRGeometry::CoordinateDimension | ( |  | ) | const
| inherited

Get the dimension of the coordinates in this object.

This method is the same as the C function OGR_G_CoordinateDimension().

Returns
  this will return 2 for XY, 3 for XYZ and XYM, and 4 for XYZM data.

Since
  GDAL 2.1

## ◆ createGEOSContext()

GEOSContextHandle_t OGRGeometry::createGEOSContext | ( |  | ) |
| static inherited

Create a new GEOS context.

Returns
  a new GEOS context.

## ◆ Crosses()

OGRBoolean OGRGeometry::Crosses | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for crossing.

Tests if this geometry and the other passed into the method are crossing.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Crosses().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if they are crossing, otherwise FALSE.

## ◆ CurveToLine()

OGRLineString * OGRCurve::CurveToLine | ( | double | dfMaxAngleStepSizeDegrees = `0`,
|  | const char *const * | papszOptions = `nullptr`
| ) |  | const
| pure virtual

Return a linestring from a curve geometry.

The returned geometry is a new instance whose ownership belongs to the caller.

If the dfMaxAngleStepSizeDegrees is zero, then a default value will be used. This is currently 4 degrees unless the user has overridden the value with the OGR_ARC_STEPSIZE configuration variable.

This method relates to the ISO SQL/MM Part 3 ICurve::CurveToLine() method.

This function is the same as C function OGR_G_CurveToLine().

Parameters

  dfMaxAngleStepSizeDegrees | the largest step in degrees along the arc, zero to use the default setting.
  papszOptions | options as a null-terminated list of strings or NULL. See OGRGeometryFactory::curveToLineString() for valid options.

Returns
  a line string approximating the curve

Since
  GDAL 2.0

Implemented in OGRCompoundCurve, OGRCircularString, and OGRLineString.

## ◆ DelaunayTriangulation()

OGRGeometry * OGRGeometry::DelaunayTriangulation | ( | double | dfTolerance,
|  | int | bOnlyEdges
| ) |  | const
| virtual inherited

Return a Delaunay triangulation of the vertices of the geometry.

This function is the same as the C function OGR_G_DelaunayTriangulation().

This function is built on the GEOS library, v3.4 or above. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  dfTolerance | optional snapping tolerance to use for improved robustness
  bOnlyEdges | if TRUE, will return a MULTILINESTRING, otherwise it will return a GEOMETRYCOLLECTION containing triangular POLYGONs.

Returns
  the geometry resulting from the Delaunay triangulation or NULL if an error occurs.

Since
  OGR 2.1

## ◆ Difference()

OGRGeometry * OGRGeometry::Difference | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute difference.

Generates a new geometry which is the region of this geometry with the region of the second geometry removed.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Difference().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry removed from "this" geometry.

Returns
  a new geometry representing the difference or NULL if the difference is empty or an error occurs.

## ◆ Disjoint()

OGRBoolean OGRGeometry::Disjoint | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for disjointness.

Tests if this geometry and the other passed into the method are disjoint.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Disjoint().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if they are disjoint, otherwise FALSE.

## ◆ Distance()

double OGRGeometry::Distance | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute distance between two geometries.

Returns the shortest distance between the two geometries. The distance is expressed into the same unit as the coordinates of the geometries.

This method is the same as the C function OGR_G_Distance().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry to compare against.

Returns
  the distance between the geometries or -1 if an error occurs.

## ◆ Distance3D()

double OGRGeometry::Distance3D | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Returns the 3D distance between two geometries.

The distance is expressed into the same unit as the coordinates of the geometries.

This method is built on the SFCGAL library, check it for the definition of the geometry operation. If OGR is built without the SFCGAL library, this method will always return -1.0

This function is the same as the C function OGR_G_Distance3D().

Returns
  distance between the two geometries

Since
  GDAL 2.2

## ◆ dumpReadable()

void OGRGeometry::dumpReadable | ( | FILE * | fp,
|  | const char * | pszPrefix = `nullptr`,
|  | char ** | papszOptions = `nullptr`
| ) |  | const
| virtual inherited

Dump geometry in well known text format to indicated output file.

A few options can be defined to change the default dump :

- DISPLAY_GEOMETRY=NO : to hide the dump of the geometry
- DISPLAY_GEOMETRY=WKT or YES (default) : dump the geometry as a WKT
- DISPLAY_GEOMETRY=SUMMARY : to get only a summary of the geometry

This method is the same as the C function OGR_G_DumpReadable().

Parameters

  fp | the text file to write the geometry to.
  pszPrefix | the prefix to put on each line of output.
  papszOptions | NULL terminated list of options (may be NULL)

## ◆ empty()

void OGRGeometry::empty | ( |  | ) |
| pure virtual inherited

Clear geometry information. This restores the geometry to its initial state after construction, and before assignment of actual geometry.

This method relates to the SFCOM IGeometry::Empty() method.

This method is the same as the C function OGR_G_Empty().

Implemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRCurvePolygon, OGRCompoundCurve, OGRSimpleCurve, and OGRPoint.

## ◆ EndPoint()

void OGRCurve::EndPoint | ( | OGRPoint * | poPoint | ) | const
| pure virtual

Return the curve end point.

This method relates to the SF COM ICurve::get_EndPoint() method.

Parameters

  poPoint | the point to be assigned the end location.

Implemented in OGRCompoundCurve, and OGRSimpleCurve.

## ◆ Equals()

int OGRGeometry::Equals | ( | const OGRGeometry * |  | ) | const
| pure virtual inherited

Returns TRUE if two geometries are equivalent.

This operation implements the SQL/MM ST_OrderingEquals() operation.

The comparison is done in a structural way, that is to say that the geometry types must be identical, as well as the number and ordering of sub-geometries and vertices. Or equivalently, two geometries are considered equal by this method if their WKT/WKB representation is equal. Note: this must be distinguished for equality in a spatial way (which is the purpose of the ST_Equals() operation).

This method is the same as the C function OGR_G_Equals().

Returns
  TRUE if equivalent or FALSE otherwise.

Implemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRCurvePolygon, OGRCompoundCurve, OGRSimpleCurve, and OGRPoint.

## ◆ exportToGEOS()

GEOSGeom OGRGeometry::exportToGEOS | ( | GEOSContextHandle_t | hGEOSCtxt | ) | const
| virtual inherited

Returns a GEOSGeom object corresponding to the geometry.

Parameters

  hGEOSCtxt | GEOS context

Returns
  a GEOSGeom object corresponding to the geometry.

## ◆ exportToGML()

char * OGRGeometry::exportToGML | ( | const char *const * | papszOptions = `nullptr` | ) | const
| virtual inherited

Convert a geometry into GML format.

The GML geometry is expressed directly in terms of GML basic data types assuming the this is available in the gml namespace. The returned string should be freed with CPLFree() when no longer required.

The supported options in OGR 1.8.0 are :

- FORMAT=GML3. Otherwise it will default to GML 2.1.2 output.
- GML3_LINESTRING_ELEMENT=curve. (Only valid for FORMAT=GML3) To use gml:Curve element for linestrings. Otherwise gml:LineString will be used .
- GML3_LONGSRS=YES/NO. (Only valid for FORMAT=GML3) Default to YES. If YES, SRS with EPSG authority will be written with the "urn:ogc:def:crs:EPSG::" prefix. In the case, if the SRS is a geographic SRS without explicit AXIS order, but that the same SRS authority code imported with ImportFromEPSGA() should be treated as lat/long, then the function will take care of coordinate order swapping. If set to NO, SRS with EPSG authority will be written with the "EPSG:" prefix, even if they are in lat/long order.

This method is the same as the C function OGR_G_ExportToGMLEx().

Parameters

  papszOptions | NULL-terminated list of options.

Returns
  A GML fragment or NULL in case of error.

## ◆ exportToJson()

char * OGRGeometry::exportToJson | ( |  | ) | const
| virtual inherited

Convert a geometry into GeoJSON format.

The returned string should be freed with CPLFree() when no longer required.

This method is the same as the C function OGR_G_ExportToJson().

Returns
  A GeoJSON fragment or NULL in case of error.

## ◆ exportToKML()

char * OGRGeometry::exportToKML | ( |  | ) | const
| virtual inherited

Convert a geometry into KML format.

The returned string should be freed with CPLFree() when no longer required.

This method is the same as the C function OGR_G_ExportToKML().

Returns
  A KML fragment or NULL in case of error.

## ◆ exportToWkb()

OGRErr OGRGeometry::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  | const
| pure virtual inherited

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb() or OGR_G_ExportToIsoWkb(), depending on the value of eWkbVariant.

Parameters

  eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOldOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns
  Currently OGRERR_NONE is always returned.

Implemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRPolygon, OGRCurvePolygon, OGRCompoundCurve, OGRCircularString, OGRSimpleCurve, and OGRPoint.

## ◆ exportToWkt() [1/2]

OGRErr OGRGeometry::exportToWkt | ( | char ** | ppszDstText,
|  | OGRwkbVariant | variant = `wkbVariantOldOgc`
| ) |  | const
| inherited

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters

  ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with CPLFree().
  variant | the specification that must be conformed too : wkbVariantOgc for old-style 99-402 extended dimension (Z) WKB types wkbVariantIso for SFSQL 1.2 and ISO SQL/MM Part 3

Returns
  Currently OGRERR_NONE is always returned.

## ◆ exportToWkt() [2/2]

virtual std::string OGRGeometry::exportToWkt | ( | const OGRWktOptions & | opts = `OGRWktOptions()`,
|  | OGRErr * | err = `nullptr`
| ) |  | const
| pure virtual inherited

Export a WKT geometry.

Parameters

  opts | Output options.
  err | Pointer to error code, if desired.

Returns
  WKT string representing this geometry.

Implemented in OGRMultiLineString, OGRMultiCurve, OGRMultiPoint, OGRPolyhedralSurface, OGRMultiPolygon, OGRMultiSurface, OGRGeometryCollection, OGRPolygon, OGRCurvePolygon, OGRCompoundCurve, OGRCircularString, OGRSimpleCurve, and OGRPoint.

## ◆ flattenTo2D()

void OGRGeometry::flattenTo2D | ( |  | ) |
| pure virtual inherited

Convert geometry to strictly 2D. In a sense this converts all Z coordinates to 0.0.

This method is the same as the C function OGR_G_FlattenTo2D().

Implemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRCurvePolygon, OGRCompoundCurve, OGRSimpleCurve, and OGRPoint.

## ◆ freeGEOSContext()

void OGRGeometry::freeGEOSContext | ( | GEOSContextHandle_t | hGEOSCtxt | ) |
| static inherited

Destroy a GEOS context.

Parameters

  hGEOSCtxt | GEOS context

## ◆ FromHandle()

static OGRGeometry* OGRGeometry::FromHandle | ( | OGRGeometryH | hGeom | ) |
| inline static inherited

Convert a OGRGeometryH to a OGRGeometry*.

Since
  GDAL 2.3

## ◆ get_Area()

double OGRCurve::get_Area | ( |  | ) | const
| pure virtual

Get the area of the (closed) curve.

This method is designed to be used by OGRCurvePolygon::get_Area().

Returns
  the area of the feature in square units of the spatial reference system in use.

Since
  GDAL 2.0

Implemented in OGRCompoundCurve, OGRCircularString, and OGRLineString.

## ◆ get_AreaOfCurveSegments()

double OGRCurve::get_AreaOfCurveSegments | ( |  | ) | const
| protected pure virtual

Get the area of the purely curve portions of a (closed) curve.

This method is designed to be used on a closed convex curve.

Returns
  the area of the feature in square units of the spatial reference system in use.

Since
  GDAL 2.0

Implemented in OGRCompoundCurve.

## ◆ get_IsClosed()

int OGRCurve::get_IsClosed | ( |  | ) | const
| virtual

Return TRUE if curve is closed.

Tests if a curve is closed. A curve is closed if its start point is equal to its end point.

For equality tests, the M dimension is ignored.

This method relates to the SFCOM ICurve::get_IsClosed() method.

Returns
  TRUE if closed, else FALSE.

## ◆ get_Length()

double OGRCurve::get_Length | ( |  | ) | const
| pure virtual

Returns the length of the curve.

This method relates to the SFCOM ICurve::get_Length() method.

Returns
  the length of the curve, zero if the curve hasn't been initialized.

Implemented in OGRCompoundCurve, OGRCircularString, and OGRSimpleCurve.

## ◆ getCoordinateDimension()

int OGRGeometry::getCoordinateDimension | ( |  | ) | const
| virtual inherited

Get the dimension of the coordinates in this object.

This method is the same as the C function OGR_G_GetCoordinateDimension().

Deprecated:
  use CoordinateDimension().

Returns
  this will return 2 or 3.

## ◆ getCurveGeometry()

OGRGeometry * OGRGeometry::getCurveGeometry | ( | const char *const * | papszOptions = `nullptr` | ) | const
| virtual inherited

Return curve version of this geometry.

Returns a geometry that has possibly CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE in it, by de-approximating curve geometries.

If the geometry has no curve portion, the returned geometry will be a clone of it.

The ownership of the returned geometry belongs to the caller.

The reverse method is OGRGeometry::getLinearGeometry().

This function is the same as C function OGR_G_GetCurveGeometry().

Parameters

  papszOptions | options as a null-terminated list of strings. Unused for now. Must be set to NULL.

Returns
  a new geometry.

Since
  GDAL 2.0

Reimplemented in OGRGeometryCollection, OGRPolygon, and OGRLineString.

## ◆ getDimension()

int OGRCurve::getDimension | ( |  | ) | const
| override virtual

Get the dimension of this object.

This method corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the object, but does not indicate the dimension of the underlying space (as indicated by OGRGeometry::getCoordinateDimension()).

This method is the same as the C function OGR_G_GetDimension().

Returns
  0 for points, 1 for lines and 2 for surfaces.

Implements OGRGeometry.

## ◆ getEnvelope() [1/2]

void OGRGeometry::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const
| pure virtual inherited

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope().

Parameters

  psEnvelope | the structure in which to place the results.

Implemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRCurvePolygon, OGRCompoundCurve, OGRCircularString, OGRSimpleCurve, and OGRPoint.

## ◆ getEnvelope() [2/2]

void OGRGeometry::getEnvelope | ( | OGREnvelope3D * | psEnvelope | ) | const
| pure virtual inherited

Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope3D().

Parameters

  psEnvelope | the structure in which to place the results.

Since
  OGR 1.9.0

Implemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRCurvePolygon, OGRCompoundCurve, OGRCircularString, OGRSimpleCurve, and OGRPoint.

## ◆ getGeometryName()

const char * OGRGeometry::getGeometryName | ( |  | ) | const
| pure virtual inherited

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Implemented in OGRMultiLineString, OGRMultiCurve, OGRMultiPoint, OGRTriangulatedSurface, OGRPolyhedralSurface, OGRMultiPolygon, OGRMultiSurface, OGRGeometryCollection, OGRTriangle, OGRPolygon, OGRCurvePolygon, OGRCompoundCurve, OGRCircularString, OGRLinearRing, OGRLineString, and OGRPoint.

## ◆ getGeometryType()

OGRwkbGeometryType OGRGeometry::getGeometryType | ( |  | ) | const
| pure virtual inherited

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This method is the same as the C function OGR_G_GetGeometryType().

Returns
  the geometry type code.

Implemented in OGRMultiLineString, OGRMultiCurve, OGRMultiPoint, OGRTriangulatedSurface, OGRPolyhedralSurface, OGRMultiPolygon, OGRMultiSurface, OGRGeometryCollection, OGRTriangle, OGRPolygon, OGRCurvePolygon, OGRCompoundCurve, OGRCircularString, OGRLineString, and OGRPoint.

## ◆ getIsoGeometryType()

OGRwkbGeometryType OGRGeometry::getIsoGeometryType | ( |  | ) | const
| inherited

Get the geometry type that conforms with ISO SQL/MM Part3.

Returns
  the geometry type that conforms with ISO SQL/MM Part3

## ◆ getLinearGeometry()

OGRGeometry * OGRGeometry::getLinearGeometry | ( | double | dfMaxAngleStepSizeDegrees = `0`,
|  | const char *const * | papszOptions = `nullptr`
| ) |  | const
| virtual inherited

Return, possibly approximate, non-curve version of this geometry.

Returns a geometry that has no CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE in it, by approximating curve geometries.

The ownership of the returned geometry belongs to the caller.

The reverse method is OGRGeometry::getCurveGeometry().

This method is the same as the C function OGR_G_GetLinearGeometry().

Parameters

  dfMaxAngleStepSizeDegrees | the largest step in degrees along the arc, zero to use the default setting.
  papszOptions | options as a null-terminated list of strings. See OGRGeometryFactory::curveToLineString() for valid options.

Returns
  a new geometry.

Since
  GDAL 2.0

Reimplemented in OGRGeometryCollection, OGRPolygon, OGRCurvePolygon, OGRCompoundCurve, and OGRCircularString.

## ◆ getNumPoints()

int OGRCurve::getNumPoints | ( |  | ) | const
| pure virtual

Return the number of points of a curve geometry.

This method, as a method of OGRCurve, does not relate to a standard. For circular strings or linestrings, it returns the number of points, conforming to SF COM NumPoints(). For compound curves, it returns the sum of the number of points of each of its components (non including intermediate starting/ending points of the different parts).

Returns
  the number of points of the curve.

Since
  GDAL 2.0

Implemented in OGRCompoundCurve, and OGRSimpleCurve.

## ◆ getPointIterator()

OGRPointIterator * OGRCurve::getPointIterator | ( |  | ) | const
| pure virtual

Returns a point iterator over the curve.

The curve must not be modified while an iterator exists on it.

The iterator must be destroyed with OGRPointIterator::destroy().

Returns
  a point iterator over the curve.

Since
  GDAL 2.0

Implemented in OGRCompoundCurve, and OGRSimpleCurve.

## ◆ getSpatialReference()

OGRSpatialReference * OGRGeometry::getSpatialReference | ( | void |  | ) | const
| inline inherited

Returns spatial reference system for object.

This method relates to the SFCOM IGeometry::get_SpatialReference() method.

This method is the same as the C function OGR_G_GetSpatialReference().

Returns
  a reference to the spatial reference object. The object may be shared with many geometry objects, and should not be modified.

## ◆ hasCurveGeometry()

OGRBoolean OGRGeometry::hasCurveGeometry | ( | int | bLookForNonLinear = `FALSE` | ) | const
| virtual inherited

Returns if this geometry is or has curve geometry.

Returns if a geometry is, contains or may contain a CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE.

If bLookForNonLinear is set to TRUE, it will be actually looked if the geometry or its subgeometries are or contain a non-linear geometry in them. In which case, if the method returns TRUE, it means that getLinearGeometry() would return an approximate version of the geometry. Otherwise, getLinearGeometry() would do a conversion, but with just converting container type, like COMPOUNDCURVE -> LINESTRING, MULTICURVE -> MULTILINESTRING or MULTISURFACE -> MULTIPOLYGON, resulting in a "loss-less" conversion.

This method is the same as the C function OGR_G_HasCurveGeometry().

Parameters

  bLookForNonLinear | set it to TRUE to check if the geometry is or contains a CIRCULARSTRING.

Returns
  TRUE if this geometry is or has curve geometry.

Since
  GDAL 2.0

Reimplemented in OGRMultiLineString, OGRMultiCurve, OGRMultiPoint, OGRPolyhedralSurface, OGRMultiPolygon, OGRMultiSurface, OGRGeometryCollection, OGRPolygon, OGRCurvePolygon, OGRCompoundCurve, and OGRCircularString.

## ◆ importFromWkb() [1/2]

OGRErr OGRGeometry::importFromWkb | ( | const GByte * | pabyData,
|  | size_t | nSize = `static_cast<size_t>(-1)`,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  |
| inherited

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters

  pabyData | the binary input data.
  nSize | the size of pabyData in bytes, or -1 if not known.
  eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

## ◆ importFromWkb() [2/2]

OGRErr OGRGeometry::importFromWkb | ( | const unsigned char * | pabyData,
|  | size_t | nSize,
|  | OGRwkbVariant | eWkbVariant,
|  | size_t & | nBytesConsumedOut
| ) |  |
| pure virtual inherited

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters

  pabyData | the binary input data.
  nSize | the size of pabyData in bytes, or -1 if not known.
  eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code
  nBytesConsumedOut | output parameter. Number of bytes consumed.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Since
  GDAL 2.3

Implemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRTriangle, OGRPolygon, OGRCurvePolygon, OGRCompoundCurve, OGRCircularString, OGRSimpleCurve, and OGRPoint.

## ◆ importFromWkt() [1/2]

OGRErr OGRGeometry::importFromWkt | ( | char ** | ppszInput | ) |
| inline inherited

Deprecated.

Deprecated:
  in GDAL 2.3

## ◆ importFromWkt() [2/2]

OGRErr OGRGeometry::importFromWkt | ( | const char ** | ppszInput | ) |
| pure virtual inherited

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters

  ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implemented in OGRMultiCurve, OGRMultiPoint, OGRPolyhedralSurface, OGRMultiSurface, OGRGeometryCollection, OGRPolygon, OGRCurvePolygon, OGRCompoundCurve, OGRCircularString, OGRSimpleCurve, and OGRPoint.

## ◆ Intersection()

OGRGeometry * OGRGeometry::Intersection | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute intersection.

Generates a new geometry which is the region of intersection of the two geometries operated on. The Intersects() method can be used to test if two geometries intersect.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Intersection().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry intersected with "this" geometry.

Returns
  a new geometry representing the intersection or NULL if there is no intersection or an error occurs.

## ◆ Intersects()

OGRBoolean OGRGeometry::Intersects | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Do these features intersect?

Determines whether two geometries intersect. If GEOS is enabled, then this is done in rigorous fashion otherwise TRUE is returned if the envelopes (bounding boxes) of the two geometries overlap.

The poOtherGeom argument may be safely NULL, but in this case the method will always return TRUE. That is, a NULL geometry is treated as being everywhere.

This method is the same as the C function OGR_G_Intersects().

Parameters

  poOtherGeom | the other geometry to test against.

Returns
  TRUE if the geometries intersect, otherwise FALSE.

Reimplemented in OGRCurvePolygon, and OGRPoint.

## ◆ IntersectsPoint()

int OGRCurve::IntersectsPoint | ( | const OGRPoint * | p | ) | const
| protected virtual

Returns if a point intersects a (closed) curve.

Final users should use OGRGeometry::Intersects() instead.

Parameters

  p | the point to test

Returns
  TRUE if it intersects the curve, FALSE otherwise or -1 if unknown.

Since
  GDAL 2.3

## ◆ Is3D()

OGRBoolean OGRGeometry::Is3D | ( |  | ) | const
| inline inherited

Returns whether the geometry has a Z component.

## ◆ IsConvex()

OGRBoolean OGRCurve::IsConvex | ( |  | ) | const
| virtual

Returns if a (closed) curve forms a convex shape.

Returns
  TRUE if the curve forms a convex shape.

Since
  GDAL 2.0

## ◆ IsEmpty()

OGRBoolean OGRGeometry::IsEmpty | ( |  | ) | const
| pure virtual inherited

Returns TRUE (non-zero) if the object has no points.

Normally this returns FALSE except between when an object is instantiated and points have been assigned.

This method relates to the SFCOM IGeometry::IsEmpty() method.

Returns
  TRUE if object is empty, otherwise FALSE.

Implemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRCurvePolygon, OGRCompoundCurve, OGRSimpleCurve, and OGRPoint.

## ◆ IsMeasured()

OGRBoolean OGRGeometry::IsMeasured | ( |  | ) | const
| inline inherited

Returns whether the geometry has a M component.

## ◆ IsRing()

OGRBoolean OGRGeometry::IsRing | ( |  | ) | const
| virtual inherited

Test if the geometry is a ring.

This method is the same as the C function OGR_G_IsRing().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return FALSE.

Returns
  TRUE if the geometry has no points, otherwise FALSE.

## ◆ IsSimple()

OGRBoolean OGRGeometry::IsSimple | ( |  | ) | const
| virtual inherited

Test if the geometry is simple.

This method is the same as the C function OGR_G_IsSimple().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return FALSE.

Returns
  TRUE if the geometry has no points, otherwise FALSE.

## ◆ IsValid()

OGRBoolean OGRGeometry::IsValid | ( |  | ) | const
| virtual inherited

Test if the geometry is valid.

This method is the same as the C function OGR_G_IsValid().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return FALSE.

Returns
  TRUE if the geometry has no points, otherwise FALSE.

Reimplemented in OGRCircularString.

## ◆ MakeValid()

OGRGeometry * OGRGeometry::MakeValid | ( | CSLConstList | papszOptions = `nullptr` | ) | const
| virtual inherited

Attempts to make an invalid geometry valid without losing vertices.

Already-valid geometries are cloned without further intervention.

Running OGRGeometryFactory::removeLowerDimensionSubGeoms() as a post-processing step is often desired.

This method is the same as the C function OGR_G_MakeValid().

This function is built on the GEOS >= 3.8 library, check it for the definition of the geometry operation. If OGR is built without the GEOS >= 3.8 library, this function will return a clone of the input geometry if it is valid, or NULL if it is invalid

Parameters

  papszOptions | NULL terminated list of options, or NULL. The following options are available: METHOD=LINEWORK/STRUCTURE. LINEWORK is the default method, which combines all rings into a set of noded lines and then extracts valid polygons from that linework. The STRUCTURE method (requires GEOS >= 3.10 and GDAL >= 3.4) first makes all rings valid, then merges shells and subtracts holes from shells to generate valid result. Assumes that holes and shells are correctly categorized. KEEP_COLLAPSED=YES/NO. Only for METHOD=STRUCTURE. NO (default): collapses are converted to empty geometries YES: collapses are converted to a valid geometry of lower dimension.

Returns
  a newly allocated geometry now owned by the caller, or NULL on failure.

Since
  GDAL 3.0

## ◆ Normalize()

OGRGeometry * OGRGeometry::Normalize | ( |  | ) | const
| virtual inherited

Attempts to bring geometry into normalized/canonical form.

This method is the same as the C function OGR_G_Normalize().

This function is built on the GEOS library; check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Returns
  a newly allocated geometry now owned by the caller, or NULL on failure.

Since
  GDAL 3.3

## ◆ Overlaps()

OGRBoolean OGRGeometry::Overlaps | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for overlap.

Tests if this geometry and the other passed into the method overlap, that is their intersection has a non-zero area.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Overlaps().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if they are overlapping, otherwise FALSE.

## ◆ Polygonize()

OGRGeometry * OGRGeometry::Polygonize | ( |  | ) | const
| virtual inherited

Polygonizes a set of sparse edges.

A new geometry object is created and returned containing a collection of reassembled Polygons: NULL will be returned if the input collection doesn't corresponds to a MultiLinestring, or when reassembling Edges into Polygons is impossible due to topological inconsistencies.

This method is the same as the C function OGR_G_Polygonize().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a newly allocated geometry now owned by the caller, or NULL on failure.

Since
  OGR 1.9.0

## ◆ segmentize()

void OGRGeometry::segmentize | ( | double | dfMaxLength | ) |
| virtual inherited

Modify the geometry such it has no segment longer then the given distance.

This method modifies the geometry to add intermediate vertices if necessary so that the maximum length between 2 consecutive vertices is lower than dfMaxLength.

Interpolated points will have Z and M values (if needed) set to 0. Distance computation is performed in 2d only

This function is the same as the C function OGR_G_Segmentize()

Parameters

  dfMaxLength | the maximum distance between 2 points after segmentization

Reimplemented in OGRGeometryCollection, OGRCurvePolygon, OGRCompoundCurve, OGRCircularString, and OGRSimpleCurve.

## ◆ set3D()

void OGRGeometry::set3D | ( | OGRBoolean | bIs3D | ) |
| virtual inherited

Add or remove the Z coordinate dimension.

This method adds or removes the explicit Z coordinate dimension. Removing the Z coordinate dimension of a geometry will remove any existing Z values. Adding the Z dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  bIs3D | Should the geometry have a Z dimension, either TRUE or FALSE.

Since
  GDAL 2.1

Reimplemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRCurvePolygon, OGRCompoundCurve, and OGRSimpleCurve.

## ◆ setCoordinateDimension()

void OGRGeometry::setCoordinateDimension | ( | int | nNewDimension | ) |
| virtual inherited

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection, a compound curve, a polygon, etc. will affect the children geometries. This will also remove the M dimension if present before this call.

Deprecated:
  use set3D() or setMeasured().

Parameters

  nNewDimension | New coordinate dimension value, either 2 or 3.

Reimplemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRCurvePolygon, OGRCompoundCurve, OGRSimpleCurve, and OGRPoint.

## ◆ setMeasured()

void OGRGeometry::setMeasured | ( | OGRBoolean | bIsMeasured | ) |
| virtual inherited

Add or remove the M coordinate dimension.

This method adds or removes the explicit M coordinate dimension. Removing the M coordinate dimension of a geometry will remove any existing M values. Adding the M dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  bIsMeasured | Should the geometry have a M dimension, either TRUE or FALSE.

Since
  GDAL 2.1

Reimplemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRCurvePolygon, OGRCompoundCurve, and OGRSimpleCurve.

## ◆ Simplify()

OGRGeometry * OGRGeometry::Simplify | ( | double | dTolerance | ) | const
| virtual inherited

Simplify the geometry.

This function is the same as the C function OGR_G_Simplify().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  dTolerance | the distance tolerance for the simplification.

Returns
  the simplified geometry or NULL if an error occurs.

Since
  OGR 1.8.0

## ◆ SimplifyPreserveTopology()

OGRGeometry * OGRGeometry::SimplifyPreserveTopology | ( | double | dTolerance | ) | const
| inherited

Simplify the geometry while preserving topology.

This function is the same as the C function OGR_G_SimplifyPreserveTopology().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  dTolerance | the distance tolerance for the simplification.

Returns
  the simplified geometry or NULL if an error occurs.

Since
  OGR 1.9.0

## ◆ StartPoint()

void OGRCurve::StartPoint | ( | OGRPoint * | poPoint | ) | const
| pure virtual

Return the curve start point.

This method relates to the SF COM ICurve::get_StartPoint() method.

Parameters

  poPoint | the point to be assigned the start location.

Implemented in OGRCompoundCurve, and OGRSimpleCurve.

## ◆ swapXY()

void OGRGeometry::swapXY | ( |  | ) |
| virtual inherited

Swap x and y coordinates.

Since
  OGR 1.8.0

Reimplemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRCurvePolygon, OGRCompoundCurve, OGRSimpleCurve, and OGRPoint.

## ◆ SymDifference()

OGRGeometry * OGRGeometry::SymDifference | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute symmetric difference.

Generates a new geometry which is the symmetric difference of this geometry and the second geometry passed into the method.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_SymDifference().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry.

Returns
  a new geometry representing the symmetric difference or NULL if the difference is empty or an error occurs.

Since
  OGR 1.8.0

## ◆ toCircularString() [1/2]

OGRCircularString* OGRGeometry::toCircularString | ( |  | ) |
| inline inherited

Down-cast to OGRCircularString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCircularString.

Since
  GDAL 2.3

## ◆ toCircularString() [2/2]

const OGRCircularString* OGRGeometry::toCircularString | ( |  | ) | const
| inline inherited

Down-cast to OGRCircularString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCircularString.

Since
  GDAL 2.3

## ◆ toCompoundCurve() [1/2]

OGRCompoundCurve* OGRGeometry::toCompoundCurve | ( |  | ) |
| inline inherited

Down-cast to OGRCompoundCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCompoundCurve.

Since
  GDAL 2.3

## ◆ toCompoundCurve() [2/2]

const OGRCompoundCurve* OGRGeometry::toCompoundCurve | ( |  | ) | const
| inline inherited

Down-cast to OGRCompoundCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCompoundCurve.

Since
  GDAL 2.3

## ◆ toCurve() [1/2]

OGRCurve* OGRGeometry::toCurve | ( |  | ) |
| inline inherited

Down-cast to OGRCurve*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbCurve).

Since
  GDAL 2.3

## ◆ toCurve() [2/2]

const OGRCurve* OGRGeometry::toCurve | ( |  | ) | const
| inline inherited

Down-cast to OGRCurve*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbCurve).

Since
  GDAL 2.3

## ◆ toCurvePolygon() [1/2]

OGRCurvePolygon* OGRGeometry::toCurvePolygon | ( |  | ) |
| inline inherited

Down-cast to OGRCurvePolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCurvePolygon or wkbPolygon or wkbTriangle.

Since
  GDAL 2.3

## ◆ toCurvePolygon() [2/2]

const OGRCurvePolygon* OGRGeometry::toCurvePolygon | ( |  | ) | const
| inline inherited

Down-cast to OGRCurvePolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCurvePolygon or wkbPolygon or wkbTriangle.

Since
  GDAL 2.3

## ◆ toGeometryCollection() [1/2]

OGRGeometryCollection* OGRGeometry::toGeometryCollection | ( |  | ) |
| inline inherited

Down-cast to OGRGeometryCollection*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbGeometryCollection).

Since
  GDAL 2.3

## ◆ toGeometryCollection() [2/2]

const OGRGeometryCollection* OGRGeometry::toGeometryCollection | ( |  | ) | const
| inline inherited

Down-cast to OGRGeometryCollection*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbGeometryCollection).

Since
  GDAL 2.3

## ◆ ToHandle()

static OGRGeometryH OGRGeometry::ToHandle | ( | OGRGeometry * | poGeom | ) |
| inline static inherited

Convert a OGRGeometry* to a OGRGeometryH.

Since
  GDAL 2.3

## ◆ toLinearRing() [1/2]

OGRLinearRing* OGRGeometry::toLinearRing | ( |  | ) |
| inline inherited

Down-cast to OGRLinearRing*.

Implies prior checking that EQUAL(getGeometryName(), "LINEARRING").

Since
  GDAL 2.3

## ◆ toLinearRing() [2/2]

const OGRLinearRing* OGRGeometry::toLinearRing | ( |  | ) | const
| inline inherited

Down-cast to OGRLinearRing*.

Implies prior checking that EQUAL(getGeometryName(), "LINEARRING").

Since
  GDAL 2.3

## ◆ toLineString() [1/2]

OGRLineString* OGRGeometry::toLineString | ( |  | ) |
| inline inherited

Down-cast to OGRLineString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbLineString.

Since
  GDAL 2.3

## ◆ toLineString() [2/2]

const OGRLineString* OGRGeometry::toLineString | ( |  | ) | const
| inline inherited

Down-cast to OGRLineString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbLineString.

Since
  GDAL 2.3

## ◆ toMultiCurve() [1/2]

OGRMultiCurve* OGRGeometry::toMultiCurve | ( |  | ) |
| inline inherited

Down-cast to OGRMultiCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiCurve and derived types.

Since
  GDAL 2.3

## ◆ toMultiCurve() [2/2]

const OGRMultiCurve* OGRGeometry::toMultiCurve | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiCurve and derived types.

Since
  GDAL 2.3

## ◆ toMultiLineString() [1/2]

OGRMultiLineString* OGRGeometry::toMultiLineString | ( |  | ) |
| inline inherited

Down-cast to OGRMultiLineString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiLineString.

Since
  GDAL 2.3

## ◆ toMultiLineString() [2/2]

const OGRMultiLineString* OGRGeometry::toMultiLineString | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiLineString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiLineString.

Since
  GDAL 2.3

## ◆ toMultiPoint() [1/2]

OGRMultiPoint* OGRGeometry::toMultiPoint | ( |  | ) |
| inline inherited

Down-cast to OGRMultiPoint*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiPoint.

Since
  GDAL 2.3

## ◆ toMultiPoint() [2/2]

const OGRMultiPoint* OGRGeometry::toMultiPoint | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiPoint*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiPoint.

Since
  GDAL 2.3

## ◆ toMultiPolygon() [1/2]

OGRMultiPolygon* OGRGeometry::toMultiPolygon | ( |  | ) |
| inline inherited

Down-cast to OGRMultiPolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiPolygon.

Since
  GDAL 2.3

## ◆ toMultiPolygon() [2/2]

const OGRMultiPolygon* OGRGeometry::toMultiPolygon | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiPolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiPolygon.

Since
  GDAL 2.3

## ◆ toMultiSurface() [1/2]

OGRMultiSurface* OGRGeometry::toMultiSurface | ( |  | ) |
| inline inherited

Down-cast to OGRMultiSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiSurface and derived types.

Since
  GDAL 2.3

## ◆ toMultiSurface() [2/2]

const OGRMultiSurface* OGRGeometry::toMultiSurface | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiSurface and derived types.

Since
  GDAL 2.3

## ◆ toPoint() [1/2]

OGRPoint* OGRGeometry::toPoint | ( |  | ) |
| inline inherited

Down-cast to OGRPoint*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPoint.

Since
  GDAL 2.3

## ◆ toPoint() [2/2]

const OGRPoint* OGRGeometry::toPoint | ( |  | ) | const
| inline inherited

Down-cast to OGRPoint*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPoint.

Since
  GDAL 2.3

## ◆ toPolygon() [1/2]

OGRPolygon* OGRGeometry::toPolygon | ( |  | ) |
| inline inherited

Down-cast to OGRPolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPolygon or wkbTriangle.

Since
  GDAL 2.3

## ◆ toPolygon() [2/2]

const OGRPolygon* OGRGeometry::toPolygon | ( |  | ) | const
| inline inherited

Down-cast to OGRPolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPolygon or wkbTriangle.

Since
  GDAL 2.3

## ◆ toPolyhedralSurface() [1/2]

OGRPolyhedralSurface* OGRGeometry::toPolyhedralSurface | ( |  | ) |
| inline inherited

Down-cast to OGRPolyhedralSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPolyhedralSurface or wkbTIN.

Since
  GDAL 2.3

## ◆ toPolyhedralSurface() [2/2]

const OGRPolyhedralSurface* OGRGeometry::toPolyhedralSurface | ( |  | ) | const
| inline inherited

Down-cast to OGRPolyhedralSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPolyhedralSurface or wkbTIN.

Since
  GDAL 2.3

## ◆ toSimpleCurve() [1/2]

OGRSimpleCurve* OGRCurve::toSimpleCurve | ( |  | ) |
| inline

Down-cast to OGRSimpleCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbLineString or wkbCircularString.

## ◆ toSimpleCurve() [2/2]

const OGRSimpleCurve* OGRCurve::toSimpleCurve | ( |  | ) | const
| inline

Down-cast to OGRSimpleCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbLineString or wkbCircularString.

## ◆ toSurface() [1/2]

OGRSurface* OGRGeometry::toSurface | ( |  | ) |
| inline inherited

Down-cast to OGRSurface*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbSurface).

Since
  GDAL 2.3

## ◆ toSurface() [2/2]

const OGRSurface* OGRGeometry::toSurface | ( |  | ) | const
| inline inherited

Down-cast to OGRSurface*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbSurface).

Since
  GDAL 2.3

## ◆ toTriangle() [1/2]

OGRTriangle* OGRGeometry::toTriangle | ( |  | ) |
| inline inherited

Down-cast to OGRTriangle*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbTriangle.

Since
  GDAL 2.3

## ◆ toTriangle() [2/2]

const OGRTriangle* OGRGeometry::toTriangle | ( |  | ) | const
| inline inherited

Down-cast to OGRTriangle*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbTriangle.

Since
  GDAL 2.3

## ◆ toTriangulatedSurface() [1/2]

OGRTriangulatedSurface* OGRGeometry::toTriangulatedSurface | ( |  | ) |
| inline inherited

Down-cast to OGRTriangulatedSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbTIN.

Since
  GDAL 2.3

## ◆ toTriangulatedSurface() [2/2]

const OGRTriangulatedSurface* OGRGeometry::toTriangulatedSurface | ( |  | ) | const
| inline inherited

Down-cast to OGRTriangulatedSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbTIN.

Since
  GDAL 2.3

## ◆ Touches()

OGRBoolean OGRGeometry::Touches | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for touching.

Tests if this geometry and the other passed into the method are touching.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Touches().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if they are touching, otherwise FALSE.

## ◆ transform()

OGRErr OGRGeometry::transform | ( | OGRCoordinateTransformation * | poCT | ) |
| pure virtual inherited

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method is the same as the C function OGR_G_Transform().

Parameters

  poCT | the transformation to apply.

Returns
  OGRERR_NONE on success or an error code.

Implemented in OGRGeometryCollection, OGRCurvePolygon, OGRCompoundCurve, OGRLinearRing, OGRSimpleCurve, OGRPoint, and OGRPolyhedralSurface.

## ◆ transformTo()

OGRErr OGRGeometry::transformTo | ( | OGRSpatialReference * | poSR | ) |
| inherited

Transform geometry to new spatial reference system.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

This method will only work if the geometry already has an assigned spatial reference system, and if it is transformable to the target coordinate system.

Because this method requires internal creation and initialization of an OGRCoordinateTransformation object it is significantly more expensive to use this method to transform many geometries than it is to create the OGRCoordinateTransformation in advance, and call transform() with that transformation. This method exists primarily for convenience when only transforming a single geometry.

This method is the same as the C function OGR_G_TransformTo().

Parameters

  poSR | spatial reference system to transform to.

Returns
  OGRERR_NONE on success, or an error code.

## ◆ Union()

OGRGeometry * OGRGeometry::Union | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute union.

Generates a new geometry which is the region of union of the two geometries operated on.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Union().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry unioned with "this" geometry.

Returns
  a new geometry representing the union or NULL if an error occurs.

## ◆ UnionCascaded()

OGRGeometry * OGRGeometry::UnionCascaded | ( |  | ) | const
| virtual inherited

Compute union using cascading.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_UnionCascaded().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry representing the union or NULL if an error occurs.

Since
  OGR 1.8.0

## ◆ Value()

void OGRCurve::Value | ( | double | dfDistance,
|  | OGRPoint * | poPoint
| ) |  | const
| pure virtual

Fetch point at given distance along curve.

This method relates to the SF COM ICurve::get_Value() method.

This function is the same as the C function OGR_G_Value().

Parameters

  dfDistance | distance along the curve at which to sample position. This distance should be between zero and get_Length() for this curve.
  poPoint | the point to be assigned the curve position.

Implemented in OGRCompoundCurve, OGRCircularString, and OGRSimpleCurve.

## ◆ Within()

OGRBoolean OGRGeometry::Within | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for containment.

Tests if actual geometry object is within the passed geometry.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Within().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if poOtherGeom is within this geometry, otherwise FALSE.

Reimplemented in OGRPoint.

## ◆ WkbSize()

int OGRGeometry::WkbSize | ( |  | ) | const
| pure virtual inherited

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns
  size of binary representation in bytes.

Implemented in OGRPolyhedralSurface, OGRGeometryCollection, OGRPolygon, OGRCurvePolygon, OGRCompoundCurve, OGRSimpleCurve, and OGRPoint.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrcurve.cpp